// test to open 2 dialogs
// written by Robert Gasch (Robert_Gasch@peoplesoft.com)
// last modified: 10AUG1999: updated for gcc-2.95

#include <string.h>
#include <gtk--.h>
#include <gtk/gtk.h>


class GuiDialogOAC : public Gtk_Dialog
	{
	public: 
					GuiDialogOAC (char *title=NULL, char *messagage=NULL);
					~GuiDialogOAC (); 
		virtual void		buildDialogWindow ();

	protected: 	
		virtual void 		fillVBox ();
		virtual void		fillActionArea ();
		virtual void 		buttonCallbackOK ();
		virtual void 		buttonCallbackApply ();
		virtual void 		buttonCallbackCancel ();
		virtual gint		delete_event_impl (GdkEventAny *e);


		Gtk_Button		d_buttonOK, 
					d_buttonApply, 
					d_buttonCancel;
		char			*d_title,
					*d_message;

	private:
		Gtk_Label		d_defaultLabel;
		Gtk_HBox		d_defaultHBox;
	};



GuiDialogOAC::GuiDialogOAC(char *title, char *message)
	      : Gtk_Dialog (),
		d_buttonOK ("OK"),
		d_buttonApply ("Apply"),
		d_buttonCancel ("Cancel"),
		d_defaultLabel (message),
		d_defaultHBox (TRUE, 5)
{
	printf ("+++ GuiDialogOAC\n");

	char 		*s;

	if (title)
		s = title;
	else
		s = "GuiDialogOAC Window";

	d_title = strdup (s);
	d_message = message;

	this->set_position (GTK_WIN_POS_MOUSE);
}


GuiDialogOAC::~GuiDialogOAC()
{
	if (d_title) delete d_title;

 	printf ("--- GuiDialogOAC\n");
}


void GuiDialogOAC::buildDialogWindow ()
{
	this->set_usize (300, 120);
	this->set_title (d_title);

	this->get_vbox()->set_border_width (2);

	fillVBox ();
	fillActionArea ();

	this->show ();
}


void GuiDialogOAC::fillVBox ()
{
	d_defaultLabel.set_justify (GTK_JUSTIFY_LEFT);
	d_defaultLabel.set_padding (0, 0);
	d_defaultHBox.pack_start (d_defaultLabel);
	d_defaultLabel.show ();
	this->get_vbox()->pack_start (d_defaultHBox, TRUE, TRUE, 0);
	d_defaultHBox.show ();
}


void GuiDialogOAC::fillActionArea ()
{
	// create new hbox and add buttons to it
	connect_to_method (d_buttonOK.clicked, this, &GuiDialogOAC::buttonCallbackOK);
	this->get_action_area()->pack_start (d_buttonOK, TRUE, TRUE, 0);
	d_buttonOK.show ();

	connect_to_method (d_buttonApply.clicked, this, &GuiDialogOAC::buttonCallbackApply);
	this->get_action_area()->pack_start (d_buttonApply, TRUE, TRUE, 0);
	d_buttonApply.show ();

	connect_to_method (d_buttonCancel.clicked, this, &GuiDialogOAC::buttonCallbackCancel);
	this->get_action_area()->pack_start (d_buttonCancel, TRUE, TRUE, 0);
	d_buttonCancel.show ();
}


void GuiDialogOAC::buttonCallbackOK ()
{
	printf ("GuiDialogOAC: Default Callback OK\n");
}


void GuiDialogOAC::buttonCallbackApply ()
{
	printf ("GuiDialogOAC: Default Callback Apply\n");
	//this->set_usize (500, 500);
	this->show ();
}


void GuiDialogOAC::buttonCallbackCancel ()
{
	this->hide ();
	exit (0);
}


gint GuiDialogOAC::delete_event_impl(GdkEventAny *)
{
	this->hide ();
	return (0);
}


int main (int argc, char *argv[])
{
	Gtk_Main	gtkMain (&argc, &argv);
	GuiDialogOAC	*testDialog;
	GuiDialogOAC	*testDialog2;

	testDialog = new GuiDialogOAC ("Default Title", "Default Message");
	testDialog->buildDialogWindow ();
	testDialog->show ();
	testDialog2 = new GuiDialogOAC ("Default Title2", "Default Message2");
	testDialog2->buildDialogWindow ();
	testDialog2->show ();
	gtkMain.run ();
}

