// last modified: 10AUG1999: updated for gcc-2.95

#include <string.h>
#include <gtk--.h>
#include <gtk/gtk.h>



#define MENU_FILE_BRANCH	"/_File"
#define MENU_FILE_RUNPROCESS	"/File/_Run and Process"
#define MENU_FILE_STRINGREPLACE "/File/_String Replace"
#define MENU_FILE_EXIT		"/File/E_xit"



/*
 *  TFWindow: the main (drawing) window for terraformer
 */
class TFWindow : public Gtk_Window
	{
	public: 
					TFWindow (); 
					~TFWindow (); 
		virtual void 		quit ();
		virtual void		fileMenuCallback (string m);
		void			setSize (int x, int y);
		void 			ShowMenu (gpointer  callback_data,
						guint     callback_action,
						Gtk_Widget *widget);

	protected: 	
		Gtk_AccelGroup			d_accelGroup;
		Gtk_VBox 			d_vbox;
		Gtk_ObjectHandle<Gtk_MenuBar> 	d_menuBarHandle;
		Gtk_ItemFactory			*d_itemFactory;
		char				**d_mNames;

		int				d_nameCount;
	};



/*
 *  constructor: build the window with an itemfactory. 
 */
TFWindow::TFWindow () : Gtk_Window (GTK_WINDOW_TOPLEVEL),
			d_accelGroup (),
       			d_vbox (FALSE, 0),
			d_itemFactory (new Gtk_ItemFactory_MenuBar("<Main>", d_accelGroup))
{

	GtkStyle		*style; 
	Gtk_Style		Style; 

	this->add (d_vbox);
	style = Style.gtkobj();
	gdk_font_unref (style->font);
	style->font = gdk_font_load ("-*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*");

    	//d_menuBarHandle = static_cast<Gtk_ObjectHandle<Gtk_MenuBar>&> (d_itemFactory->get_menubar_widget(""));
	{
	// uglier than above but without compiler warning 
	Gtk_ObjectHandle<Gtk_MenuBar> a(d_itemFactory->get_menubar_widget(""));
    	d_menuBarHandle = a;
	}

	d_menuBarHandle->push_style (Style);

	d_itemFactory->create_item (MENU_FILE_BRANCH, "<alt>F", "<Branch>", 0);
	d_itemFactory->create_item (MENU_FILE_RUNPROCESS, "<control>N", "", 
		ItemFactoryConnector<TFWindow, string>(this,&TFWindow::fileMenuCallback, MENU_FILE_RUNPROCESS));
	d_itemFactory->create_item (MENU_FILE_EXIT, 0, "", 
		ItemFactoryConnector<TFWindow, string>(this,&TFWindow::fileMenuCallback, MENU_FILE_EXIT));

	this->add_accel_group (d_accelGroup);

	d_vbox.pack_start(*d_menuBarHandle, FALSE, FALSE, 0);
	//connect_to_method(ebox.button_press_event, this, &(buttonPress));
	//d_menuBarHandle->show();

	// catch destroy event
	connect_to_method (destroy, this, &TFWindow::quit);

	d_vbox.show();
	d_menuBarHandle->show();
	this->set_usize (200, 50);
	this->show();
}


/*
 *  destructor: clean up 
 */
TFWindow::~TFWindow()
{
}


void TFWindow::quit ()
{
	gtk_exit (0);
}


void TFWindow::fileMenuCallback(string m)
{
	if (m == MENU_FILE_EXIT)
		quit ();
	cout << "Callback " << m << " caught " << endl;
}


void TFWindow::setSize (int x, int y)
{
	this->set_usize (x, y+d_menuBarHandle->height());
	this->show();
}


int main (int argc, char *argv[])
{
	Gtk_Main        gtkMain (&argc, &argv);
	TFWindow	*tWin;

        tWin = new TFWindow ();
        gtkMain.run ();
}

