// last modified: 10AUG1999: updated for gcc-2.95

#include <string.h>
#include <gtk--.h>
#include <gtk/gtk.h>



#define MENU_FILE_BRANCH	"/_File"
#define MENU_FILE_RUNPROCESS	"/File/_Run and Process"
#define MENU_FILE_STRINGREPLACE "/File/_String Replace"
#define MENU_FILE_EXIT		"/File/E_xit"



/*
 *  TFWindow: the main (drawing) window for terraformer
 */
class TFWindow : public Gtk_Window
	{
	public: 
					TFWindow (); 
					~TFWindow (); 
		virtual void 		quit ();
		virtual void		fileMenuCallback (string m);
		void			setSize (int x, int y);
		void 			ShowMenu (gpointer  callback_data,
						guint     callback_action,
						Gtk_Widget *widget);
		int			buttonPressCallback (GdkEventButton *e);

	protected: 	
		Gtk_AccelGroup			d_accelGroup;
		Gtk_Button			d_button;
		Gtk_VBox 			d_vbox;
		Gtk_ObjectHandle<Gtk_Menu>	d_menuHandle;
		Gtk_ItemFactory			*d_itemFactory;
		char				**d_mNames;

		int				d_nameCount;
	};



/*
 *  constructor: build the window with an itemfactory. 
 */
TFWindow::TFWindow () : Gtk_Window (GTK_WINDOW_TOPLEVEL),
			d_accelGroup (),
			d_button ("Press me"),
       			d_vbox (FALSE, 0),
			d_itemFactory (new Gtk_ItemFactory_Menu("<Main>", d_accelGroup))
{

	GtkStyle		*style; 
	Gtk_Style		Style; 

	this->add (d_vbox);
	style = Style.gtkobj();
	gdk_font_unref (style->font);
	style->font = gdk_font_load ("-*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*");

	{
	// uglier than above but without compiler warning 
	Gtk_ObjectHandle<Gtk_Menu> b(d_itemFactory->get_menu_widget(""));
    	d_menuHandle = b;
	}
	d_menuHandle->push_style (Style);

	d_itemFactory->create_item (MENU_FILE_BRANCH, "<alt>F", "<Branch>", 0);
	d_itemFactory->create_item (MENU_FILE_RUNPROCESS, "<control>N", "", 
		ItemFactoryConnector<TFWindow, string>(this,&TFWindow::fileMenuCallback, MENU_FILE_RUNPROCESS));
	d_itemFactory->create_item (MENU_FILE_EXIT, 0, "", 
		ItemFactoryConnector<TFWindow, string>(this,&TFWindow::fileMenuCallback, MENU_FILE_EXIT));

	this->add_accel_group (d_accelGroup);

	connect_to_method (d_button.button_press_event, this, &TFWindow::buttonPressCallback);
	d_vbox.pack_start(d_button, TRUE, TRUE, 0);
	d_button.show ();

	// catch destroy event
	connect_to_method (destroy, this, &TFWindow::quit);

	d_vbox.show();
	this->set_usize (200, 50);
	this->show();
}


/*
 *  destructor: clean up 
 */
TFWindow::~TFWindow()
{
}


void TFWindow::quit ()
{
	gtk_exit (0);
}


void TFWindow::fileMenuCallback(string m)
{
	if (m == MENU_FILE_EXIT)
		quit ();
	cout << "Callback " << m << " caught " << endl;
}


int TFWindow::buttonPressCallback (GdkEventButton *e)
{
        d_menuHandle->popup (NULL, NULL, e->button, e->time);
        /* Tell calling code that we have handled this event; the buck
         * stops here. */
        return TRUE;
}


void TFWindow::setSize (int x, int y)
{
	this->set_usize (x, y);
	this->show();
}


int main (int argc, char *argv[])
{
	Gtk_Main        gtkMain (&argc, &argv);
	TFWindow	*tWin;

        tWin = new TFWindow ();
        gtkMain.run ();
}

