// last modified: 10AUG1999: updated for gcc-2.95


#include "GuiDialogOAC.h"				// include gtk, gtk--


class Preview : public GuiDialogOAC
	{
	public: 
				Preview ();
				~Preview (); 
		void		buildDialogWindow ();
		void 		buttonCallbackOK ();
		void 		buttonCallbackApply ();

	private:
		void		fillVBox ();
		gint 		delete_event_impl (GdkEventAny *);

		Gtk_VBox 	d_vBoxList;
		Gtk_Preview	*preview;
	};


Preview::Preview () : GuiDialogOAC ("Preview Test Dialog", "Test"),
		  d_vBoxList (TRUE, 5)
{
	preview = NULL;
	buildDialogWindow ();
	
}


Preview::~Preview ()
{
	if (preview)
		delete preview;
}


void Preview::fillVBox ()
{
	int	size=100;
	guchar 	*row = new unsigned char [3*size];
	
	
	this->d_baseFrame->add (d_vBoxList);

	preview = new Gtk_Preview (GTK_PREVIEW_COLOR);
	preview->size (size, size);
	d_vBoxList.pack_start (*preview, TRUE, TRUE, 3);
	preview->show ();
	d_vBoxList.show ();

	for (int i=0; i<size; i++)
	   for (int j=0; j<size; j++)
		{
		row[j*3]=(int) (255.0/size*i);
		row[j*3+1]=(int) (255.0/size*i);
		row[j*3+2]=(int) (255.0/size*i);
		preview->draw_row (row, 0, i, size);
		}
	delete [] row;
}


/*
 *  buildDialogWindow:
 */
void Preview::buildDialogWindow ()
{
	this->set_usize (200, 250);
	this->set_title (this->d_winTitle);

	this->get_vbox()->set_border_width (2);

	this->setupVBox ();
	fillVBox ();
	fillActionArea ();

	this->d_baseFrame->show ();
	this->show ();
}


void Preview::buttonCallbackOK ()
{	
	this->hide ();
	gdk_flush ();
	buttonCallbackApply ();
}


/*
 *  buttonCallbackApply: rotate the Height Field
 */
void Preview::buttonCallbackApply ()
{
}


gint Preview::delete_event_impl (GdkEventAny *)
{
	this->hide ();
	return (0);
}


int main (int argc, char *argv[])
{
	Gtk_Main        gtkMain (&argc, &argv);
	Preview *testDialog;

	testDialog = new Preview ();
	testDialog->show ();
	gtkMain.run ();
}
